Public Class frmBGExportProfileigenschaften
    ' entspricht dem, über die Toolbar-Combobox ausgewählten, Profil und enthält alle relevanten Informationen darüber
    Private _selectedProfile As ClassBWProfilExport
    Private prof_loaded As Boolean = True
    ' verhindert (wenn True) das selectedProfile auf Nothing gesetzt wird, wenn das Panel auf visible = True gesetzt wird
    Private _flagIgnoreVisibilityChanged As Boolean = False
    Private Shared _Instance As frmBGExportProfileigenschaften = Nothing
    Public Shared Function Instance() As frmBGExportProfileigenschaften
        If _Instance Is Nothing OrElse _Instance.IsDisposed = True Then
            _Instance = New frmBGExportProfileigenschaften
        End If
        _Instance.BringToFront()
        Return _Instance
    End Function
    Public Shared vSQL As String
    Private email As New ClassBWExportEmail
    ''' <summary>
    ''' Konstruktor des Panels. Laden der Profilnamen in die Auswahliste.
    ''' </summary>
    ''' <remarks></remarks>
    Sub New()

        ' Dieser Aufruf ist für den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' alle Profile in die Toolbar-Combobox eintragen
        Me.LoadProfilesInCombobox()
    End Sub


    ' ++++++++++++++++++++++++++++++++++++++++++++++ Methoden ++++++++++++++++++++++++++++++++++++++++++++++

    ''' <summary>
    ''' Schreibt die Profile in die Combobox in der Toolbar.
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub LoadProfilesInCombobox()
        Try
            ClassBWProfileExport.Init()
            Me.cmbProfilauswahl.DropDownItems.Clear()
            If ClassBWProfileExport.Profile IsNot Nothing Then
                For Each item As ClassBWProfilExport In ClassBWProfileExport.Profile
                    Me.cmbProfilauswahl.DropDownItems.Add(item.Profilname)
                Next
            End If
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Critical, "Fehler beim Laden der Profile in die Auswahlliste")
        End Try
    End Sub

    ''' <summary>
    ''' Wenn Änderungen am Profil vorgenommen wurden, wird gefragt ob das Profil gespeichert werden soll.
    '''   Yes    : Profil wird gespeichert und anschließend wird das Hauptpanel geschlossen
    '''   No     : das Hauptpanel wird geschlossen (ohne Speichern)
    '''   Cancel : das Schließen des Hauptpanels wird verhindert (das Profil bleibt erhalten)
    ''' </summary>
    ''' <returns>Gibt False zurück, wenn die Aktion abgebrochen wurde, sonst True.</returns>
    ''' <remarks></remarks>
    Private Sub frmNIProfileigenschaften_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If Check_Aenderung() = "Abbruch" Then
            e.Cancel = True
        End If
    End Sub
    Private Function Check_Aenderung()
        '####
        ' wenn ein Profil gewählt ist
        If Me._selectedProfile IsNot Nothing Then
            ' wenn es Änderungen am Profil gibt
            If Me._selectedProfile.HasChanges Then
                Dim result As MsgBoxResult = MsgBox("Möchten Sie Ihre Änderungen vor dem Schließen/Wechseln speichern?", MsgBoxStyle.YesNoCancel, "Änderungen übernehmen")

                If result = MsgBoxResult.Yes Then           ' wenn die Daten gespeichert werden sollen

                    ' die Änderungen speichern
                    If Me._selectedProfile.Save(True) = True Then    ' wenn das Speichern erfolgreich war
                        ' die Profile neu in die Combobox der Toolbar laden (für den Fall das Profilname geändert wurde)
                        Me.LoadProfilesInCombobox()

                        ' die Profileigenschaften auf diesem Panel ausblenden
                        ' den Speichern-Button deaktivieren 
                        Me.btnSpeichern.Enabled = False
                        ' den Löschen-Button deaktivieren 
                        Me.btnLöschen.Enabled = False
                        ' kein selectedProfile wählen
                        Me._selectedProfile = Nothing
                        Return "Gespeichert"

                    End If

                ElseIf result = MsgBoxResult.No Then        ' wenn die Daten verworfen werden sollen

                    ' wenn ein Profil selektiert ist: den originalen Profilnamen setzen
                    If Me._selectedProfile IsNot Nothing Then Me._selectedProfile.SetBackToOriginal()

                    ' den Speichern-Button deaktivieren 
                    Me.btnSpeichern.Enabled = False
                    ' den Löschen-Button deaktivieren 
                    Me.btnLöschen.Enabled = False
                    ' kein selectedProfile wählen
                    Return "Nein"

                ElseIf result = MsgBoxResult.Cancel Then    ' wenn die Aktion abgebrochen werden soll
                    ' die nachfolgende Aktion (das Schließen aller Fenster und das Öffnen des neuen) wird verhindert
                    Return "Abbruch"
                End If

            Else  ' wenn keine Änderungen gemacht wurden
                Return "keineAenderung"
                ' wenn ein Profil selektiert ist: den originalen Profilnamen setzen
                If Me._selectedProfile IsNot Nothing Then Me._selectedProfile.SetBackToOriginal()
                ' den Speichern-Button deaktivieren 
                Me.btnSpeichern.Enabled = False
                ' den Löschen-Button deaktivieren 
                Me.btnLöschen.Enabled = False
            End If
        End If

        'Catch ex As Exception
        '    MsgBox(ex.Message, MsgBoxStyle.Critical, "Fehler beim Überprüfen auf Änderungen an Profilen:")
        'End Try

    End Function


    ' +++ Anzeige-Events +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    ' +++ Formular-Events +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


    Private Sub cmbProfilauswahl_DropDownItemClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ToolStripItemClickedEventArgs) Handles cmbProfilauswahl.DropDownItemClicked
        ' wenn bereits ein Profil ausgewählt wurde
        If Me._selectedProfile IsNot Nothing Then
            ' wenn es sich bei dem ausgewählten Element um das gleiche handelt wie das Aktive, dann nichts tun
            If e.ClickedItem.Text = Me._selectedProfile.Profilname Then Exit Sub
            'Ansonsten sehen ob gespeichert werden mss
            Profil_speichern()
        End If
        'Select Case Check_Aenderung()
        '    Case "Gespeichert"
        '    Case Nothing
        '        MsgBox("Nothing")
        '    Case Else
        '        MsgBox(Check_Aenderung.ToString())
        'End Select

        ' das ausgewählte Profil in selectedProfile laden
        Me._selectedProfile = ClassBWProfileExport.getProfilByName(e.ClickedItem.Text)

        ' wenn das selektierte Profil gefunden wurde
        If Me._selectedProfile IsNot Nothing Then
            prof_loaded = False
            Me.pnlEigenschaften.Enabled = True
            ' die Steuerelemente für die Profilinformationen mit den Daten füllen
            Me.txtProfilname.Text = Me._selectedProfile.Profilname

            Me.txtSQL.Text = Me._selectedProfile.vSQL_Anweisung
            Me.cmbDateiformat.SelectedItem = Me._selectedProfile.Format
            Me.txtSpeicherort.Text = Me._selectedProfile.Path

            Me.txtDays.Text = Me._selectedProfile.Days
            CheckBox1.Checked = False
            CheckBox2.Checked = False
            CheckBox3.Checked = False
            CheckBox4.Checked = False
            CheckBox5.Checked = False
            CheckBox6.Checked = False
            CheckBox7.Checked = False
            'Markieren der Checkboxen'
            If Me._selectedProfile.Days.Substring(0, 1) = 1 Then
                CheckBox1.Checked = True
            End If
            If Me._selectedProfile.Days.Substring(1, 1) = 1 Then
                CheckBox2.Checked = True
            End If
            If Me._selectedProfile.Days.Substring(2, 1) = 1 Then
                CheckBox3.Checked = True
            End If
            If Me._selectedProfile.Days.Substring(3, 1) = 1 Then
                CheckBox4.Checked = True
            End If
            If Me._selectedProfile.Days.Substring(4, 1) = 1 Then
                CheckBox5.Checked = True
            End If
            If Me._selectedProfile.Days.Substring(5, 1) = 1 Then
                CheckBox6.Checked = True
            End If
            If Me._selectedProfile.Days.Substring(6, 1) = 1 Then
                CheckBox7.Checked = True
            End If
            Me.txtlastExport.Text = Me._selectedProfile._lastExport

            Me.chkEmail.Checked = Me._selectedProfile.Email
            Me.txtEmailto.Text = Me._selectedProfile.Emailto
            Me.txtAbsender.Text = Me._selectedProfile.EmailAbsender
            Me.txtBetreff.Text = Me._selectedProfile.EmailBetreff
            Me.txtBody.Text = Me._selectedProfile.EmailBody
            Me.txtMail_from.Text = Me._selectedProfile.Emailfrom
            Me.txtSMTP.Text = Me._selectedProfile.EmailSMTP
            Me.txtUser.Text = Me._selectedProfile.EmailUser
            Me.txtEmailPasswort.Text = Me._selectedProfile.EmailPW
            Me.txtEmail_Bestaetigung.Text = Me._selectedProfile.emailbest

            ' Das Profil auf gespeichert setzen, da ja keine Änderungen am Profil selbst gemacht wurden. Das Profil
            ' hat jedoch zu diesem Zeitpunkt den Status HasChanges(), da der Inhalt der Steuerelemente verändert wurde.
            Me._selectedProfile.setSaved()
            prof_loaded = True
        End If

        ' den Löschen-Button aktivieren 
        Me.btnLöschen.Enabled = True
    End Sub
    Private Sub txtProfilname_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtProfilname.TextChanged
        If Me._selectedProfile IsNot Nothing Then
            Me._selectedProfile.Profilname = Me.txtProfilname.Text
            If Not Me.txtProfilname.Text = Me._selectedProfile.OriginalProfilname Then
                Me.btnSpeichern.Enabled = True
            Else
                Me.btnSpeichern.Enabled = False
            End If
        End If
    End Sub

    Private Sub btnSpeichern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSpeichern.Click
        Profil_speichern()
    End Sub
    Sub Profil_speichern()
        Dim originalProfilname As String = Me._selectedProfile.OriginalProfilname

        ' wenn kein Profil gewählt wurde, soll das Event abgebrochen werden
        If Me._selectedProfile Is Nothing Then Exit Sub

        ' wenn Veränderungen am Profil gemacht wurden
        If Me._selectedProfile.HasChanges Then

            If Me.txtProfilname.Text = "" Then
                MsgBox("Es wurde kein Profilname angegeben. Bitte tragen Sie einen in das Feld Profilname ein.", MsgBoxStyle.Information, "Eingabe erwartet")
                Exit Sub
            End If

            If Me.CheckBox1.Checked = False Then
                If Me.CheckBox2.Checked = False Then
                    If Me.CheckBox3.Checked = False Then
                        If Me.CheckBox4.Checked = False Then
                            If Me.CheckBox5.Checked = False Then
                                If Me.CheckBox6.Checked = False Then
                                    If Me.CheckBox7.Checked = False Then
                                        MsgBox("Bitte definieren Sie mindestens einen Wochentag an dem der Export durchgeführt werden soll.", MsgBoxStyle.Information, "Eingabe erwartet")
                                        Exit Sub
                                    End If
                                End If
                            End If
                        End If
                    End If
                End If
            End If


            ' prüfen ob der Profilname geändert wurde
            If Not Me._selectedProfile.OriginalProfilname = Me.txtProfilname.Text Then
                ' prüfen ob der eingegebene Profilname schon vorhanden ist
                If ClassBWProfileExport.Exists(Me.txtProfilname.Text) Then
                    MsgBox("Der angegebene Profilname existiert bereits. Bitte wählen Sie einen anderen Profilnamen.", MsgBoxStyle.Information, "Ungültige Eingabe")
                    Exit Sub
                Else
                    ' sonst den neuen Profilnamen vorerst einmal ändern
                    Me._selectedProfile.Profilname = Me.txtProfilname.Text
                End If
            End If



            ' die Änderungen speichern
            If Me._selectedProfile.Save(True) = True Then    ' wenn das Speichern erfolgreich war
                ' den Speichern-Button deaktivieren 
                Me.btnSpeichern.Enabled = False
                ' die Profile neu in die Combobox der Toolbar laden (für den Fall das Profilname geändert wurde)
                Me.LoadProfilesInCombobox()
            Else
                MsgBox("Das Profil konnte nicht erfolgreich gespeichert werden.", MsgBoxStyle.Exclamation, "Fehler beim Speichern eines Profils")

                Me.txtProfilname.Text = originalProfilname
            End If

        End If
    End Sub
    Private Sub btnLöschen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLöschen.Click
        ' Fragen ob das Profil wirklich gelöscht werden soll
        Dim result As MsgBoxResult = MsgBox("Sind Sie sicher, dass sie das Profil '" & Me._selectedProfile.OriginalProfilname & "' löschen möchten?", MsgBoxStyle.YesNo, "Profil löschen")

        ' wenn das Profil gelöscht werden soll
        If result = MsgBoxResult.Yes Then
            ' das Profil löschen
            If ClassBWProfileExport.DeleteProfil(Me._selectedProfile.OriginalProfilname) Then
                ' den Speichern-Button deaktivieren 
                Me.btnSpeichern.Enabled = False
                ' den Löschen-Button deaktivieren 
                Me.btnLöschen.Enabled = False
                ' kein Profil als selektiert wählen
                Me._selectedProfile = Nothing
                ' die Profile neu in die Combobox laden
                Me.LoadProfilesInCombobox()
            End If
        End If
    End Sub
    Private Sub txtSQL_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtSQL.TextChanged
        If Me._selectedProfile IsNot Nothing Then
            Me._selectedProfile.vSQL_Anweisung = Me.txtSQL.Text
            If Not Me._selectedProfile.vSQL_Anweisung = Me._selectedProfile.OriginalvSQL_Anweisung Then
                Me.btnSpeichern.Enabled = True
            Else
                Me.btnSpeichern.Enabled = False
            End If
            If Me._selectedProfile.vSQL_Anweisung Is Nothing = False Then
                Me.btnTestErgebnis.Enabled = True
            Else
                Me.btnTestErgebnis.Enabled = False
            End If
        End If
    End Sub
    Private Sub btnDialogSpeicherort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDialogSpeicherort.Click
        If Me.FolderBrowserDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            Me.txtSpeicherort.Text = Me.FolderBrowserDialog1.SelectedPath
        End If
    End Sub

    Private Sub btnHinzufügen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnHinzufügen.Click
        frmBGExportProfilhinzufuegen.ShowDialog()
        ' wenn das Formular geschlossen wurde, werden die Profile neu in die Combobox geladen
        Me.LoadProfilesInCombobox()
    End Sub

    Private Sub btnTestErgebnis_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTestErgebnis.Click
        vSQL = Me.txtSQL.Text

        Dim FMTest_SQL As System.Windows.Forms.Form = New frmSQLTest()
            FMTest_SQL.ShowDialog()
    End Sub

    Private Sub chkEmail_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkEmail.CheckedChanged
        If Me._selectedProfile IsNot Nothing Then
            Me._selectedProfile.Email = chkEmail.CheckState
            If Not Me._selectedProfile.Email = Me._selectedProfile.originalEmail Then
                Me.btnSpeichern.Enabled = True
            Else
                Me.btnSpeichern.Enabled = False
            End If
        End If
        If Me.chkEmail.Checked Then
            Me.grbEmail.Enabled = True
        Else
            Me.grbEmail.Enabled = False
        End If
    End Sub

    Private Sub txtEmailto_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtEmailto.TextChanged
        If Me._selectedProfile IsNot Nothing Then
            Me._selectedProfile.Emailto = Me.txtEmailto.Text
            If Not Me._selectedProfile.Emailto = Me._selectedProfile.originalEmailto Then
                Me.btnSpeichern.Enabled = True
            Else
                Me.btnSpeichern.Enabled = False
            End If
        End If
    End Sub

    Private Sub txtBetreff_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtBetreff.TextChanged
        If Me._selectedProfile IsNot Nothing Then
            Me._selectedProfile.EmailBetreff = Me.txtBetreff.Text
            If Not Me._selectedProfile.EmailBetreff = Me._selectedProfile.originalEmailBetreff Then
                Me.btnSpeichern.Enabled = True
            Else
                Me.btnSpeichern.Enabled = False
            End If
        End If
    End Sub

    Private Sub txtBody_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtBody.TextChanged
        If Me._selectedProfile IsNot Nothing Then
            Me._selectedProfile.EmailBody = Me.txtBody.Text
            If Not Me._selectedProfile.EmailBody = Me._selectedProfile.originalEmailBody Then
                Me.btnSpeichern.Enabled = True
            Else
                Me.btnSpeichern.Enabled = False
            End If
        End If
    End Sub

    Private Sub btntestemail_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btntestemail.Click
        Me.Cursor = Cursors.WaitCursor
        Try
            If Me.txtBetreff.Text = "" Or Me.txtEmailto.Text = "" Or Me.txtMail_from.Text = "" Or Me.txtUser.Text = "" Or Me.txtEmailPasswort.Text = "" Or _
            Me.txtSMTP.Text = "" Then
                MsgBox("Bitte achten sie darauf alle Konfigurationsfelder für die Email-Generierung auszufüllen!", MsgBoxStyle.Critical, "Fehlende Eingaben:")
            Else
                Dim Mail As New ClassBWExportEmail
                'Den/die Empfänger auslesen
                Dim emp As String()
                If Me._selectedProfile.Emailto.Contains(";") Then
                    emp = Me._selectedProfile.Emailto.Split(";")
                Else
                    ReDim Preserve emp(0)
                    emp(0) = Me._selectedProfile.Emailto
                End If
                'Die Mail zusammenbauen und versenden
                With Mail
                    .Absender(Me._selectedProfile.Emailfrom, Me._selectedProfile.EmailAbsender)
                    For Each _empAdress As String In emp
                        .Empfänger(_empAdress, _empAdress)

                        .Nachricht(Me._selectedProfile.EmailBetreff & " TEST-EMAIL", "<font face=""Arial"">" & Me._selectedProfile.EmailBody & "<br> Gesendet am: " & My.Computer.Clock.LocalTime.ToShortDateString & "-" & _
                                   My.Computer.Clock.LocalTime.ToLongTimeString & "</font>")

                        .Nachricht_Einstellungen(True, Net.Mail.MailPriority.Normal)
                        .Senden_MitAuthenzierung(Me._selectedProfile.EmailUser, Me._selectedProfile.EmailPW, Me._selectedProfile.EmailSMTP, True)
                    Next
                End With

                'email.Send_EMail(Me._selectedProfile.EmailBody, Me._selectedProfile.Emailfrom, Me._selectedProfile.Emailto, Me._selectedProfile.EmailBetreff & " TEST-EMAIL", Me._selectedProfile.EmailSMTP, Me._selectedProfile.EmailUser, _
                '                 Me._selectedProfile.EmailPW, "", True) '  Gesendet am: " & My.Computer.Clock.LocalTime.ToShortDateString & "-" & My.Computer.Clock.LocalTime.ToLongTimeString
            End If
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Critical, "Fehler bei btntestmail.Click:")
        End Try
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub txtMail_from_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtMail_from.TextChanged
        If Me._selectedProfile IsNot Nothing Then
            Me._selectedProfile.Emailfrom = Me.txtMail_from.Text
            If Not Me._selectedProfile.Emailfrom = Me._selectedProfile.originalEmailfrom Then
                Me.btnSpeichern.Enabled = True
            Else
                Me.btnSpeichern.Enabled = False
            End If
        End If
    End Sub

    Private Sub txtSMTP_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtSMTP.TextChanged
        If Me._selectedProfile IsNot Nothing Then
            Me._selectedProfile.EmailSMTP = Me.txtSMTP.Text
            If Not Me._selectedProfile.EmailSMTP = Me._selectedProfile.originalEmailSMTP Then
                Me.btnSpeichern.Enabled = True
            Else
                Me.btnSpeichern.Enabled = False
            End If
        End If
    End Sub

    Private Sub txtUser_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtUser.TextChanged
        If Me._selectedProfile IsNot Nothing Then
            Me._selectedProfile.EmailUser = Me.txtUser.Text
            If Not Me._selectedProfile.EmailUser = Me._selectedProfile.originalEmailUser Then
                Me.btnSpeichern.Enabled = True
            Else
                Me.btnSpeichern.Enabled = False
            End If
        End If
    End Sub

    Private Sub txtPasswort_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtEmailPasswort.TextChanged
        If Me._selectedProfile IsNot Nothing Then
            Me._selectedProfile.EmailPW = txtEmailPasswort.Text
            If Not Me._selectedProfile.EmailPW = Me._selectedProfile.originalEmailPW Then
                Me.btnSpeichern.Enabled = True
            Else
                Me.btnSpeichern.Enabled = False
            End If
        End If
    End Sub
    Private Sub txtSpeicherort_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtSpeicherort.TextChanged
        If Me._selectedProfile IsNot Nothing Then
            Me._selectedProfile.Path = txtSpeicherort.Text
            If Not Me._selectedProfile.Path = Me._selectedProfile.originalpath Then
                Me.btnSpeichern.Enabled = True
            Else
                Me.btnSpeichern.Enabled = False
            End If
        End If
    End Sub

    Private Sub cmbDateiformat_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbDateiformat.SelectedIndexChanged
        If Me._selectedProfile IsNot Nothing Then

            Me._selectedProfile.Format = Me.cmbDateiformat.SelectedItem
            If Not Me._selectedProfile.Format = Me._selectedProfile.originalFormat Then
                Me.btnSpeichern.Enabled = True
            Else
                Me.btnSpeichern.Enabled = False
            End If
        End If
    End Sub

    Private Sub txtAbsender_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtAbsender.TextChanged
        If Me._selectedProfile IsNot Nothing Then
            Me._selectedProfile.EmailAbsender = Me.txtAbsender.Text
            If Not Me._selectedProfile.EmailAbsender = Me._selectedProfile.originalEmailabsender Then
                Me.btnSpeichern.Enabled = True
            Else
                Me.btnSpeichern.Enabled = False
            End If
        End If
    End Sub

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        If CheckBox1.Checked Then
            ' MsgBox(txtDays.Text & vbNewLine & txtDays.Text.Substring(1))
            Me.txtDays.Text = "1" & txtDays.Text.Substring(1)
        Else
            ' MsgBox(txtDays.Text & vbNewLine & txtDays.Text.Substring(1))
            Me.txtDays.Text = "0" & txtDays.Text.Substring(1)
        End If
    End Sub

    Private Sub CheckBox2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox2.CheckedChanged
        If prof_loaded = True Then
            If CheckBox2.Checked Then
                Me.txtDays.Text = txtDays.Text.Substring(0, 1) & "1" & txtDays.Text.Substring(2)
            Else
                Me.txtDays.Text = txtDays.Text.Substring(0, 1) & "0" & txtDays.Text.Substring(2)
            End If
        End If
       
    End Sub

    Private Sub CheckBox3_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox3.CheckedChanged
        If prof_loaded = True Then
            If CheckBox3.Checked Then
                Me.txtDays.Text = txtDays.Text.Substring(0, 2) & "1" & txtDays.Text.Substring(3)
            Else
                Me.txtDays.Text = txtDays.Text.Substring(0, 2) & "0" & txtDays.Text.Substring(3)
            End If
        End If
      
    End Sub

    Private Sub CheckBox4_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox4.CheckedChanged
        If prof_loaded = True Then
            If CheckBox4.Checked Then
                Me.txtDays.Text = txtDays.Text.Substring(0, 3) & "1" & txtDays.Text.Substring(4)
            Else
                Me.txtDays.Text = txtDays.Text.Substring(0, 3) & "0" & txtDays.Text.Substring(4)
            End If
        End If
       
    End Sub

    Private Sub CheckBox5_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox5.CheckedChanged
        If prof_loaded = True Then
            If CheckBox5.Checked Then
                Me.txtDays.Text = txtDays.Text.Substring(0, 4) & "1" & txtDays.Text.Substring(5)
            Else
                Me.txtDays.Text = txtDays.Text.Substring(0, 4) & "0" & txtDays.Text.Substring(5)
            End If
        End If
       
    End Sub

    Private Sub CheckBox6_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox6.CheckedChanged
        If prof_loaded = True Then
            If CheckBox6.Checked Then
                Me.txtDays.Text = txtDays.Text.Substring(0, 5) & "1" & txtDays.Text.Substring(6)
            Else
                Me.txtDays.Text = txtDays.Text.Substring(0, 5) & "0" & txtDays.Text.Substring(6)
            End If
        End If
        
    End Sub

    Private Sub CheckBox7_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox7.CheckedChanged
        If prof_loaded = True Then
            If CheckBox7.Checked Then
                Me.txtDays.Text = txtDays.Text.Substring(0, 6) & "1"
            Else
                Me.txtDays.Text = txtDays.Text.Substring(0, 6) & "0"
            End If
        End If
    End Sub

    Private Sub txtDays_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtDays.TextChanged
        If Me._selectedProfile IsNot Nothing Then
            Me._selectedProfile.Days = Me.txtDays.Text
            If Not Me._selectedProfile.Days = Me._selectedProfile.originaldays Then
                Me.btnSpeichern.Enabled = True
            Else
                Me.btnSpeichern.Enabled = False
            End If
        End If
    End Sub

    Private Sub txtEmail_Bestaetigung_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtEmail_Bestaetigung.TextChanged
        If Me._selectedProfile IsNot Nothing Then
            Me._selectedProfile.emailbest = Me.txtEmail_Bestaetigung.Text
            If Not Me._selectedProfile.emailbest = Me._selectedProfile.originalEmailBest Then
                Me.btnSpeichern.Enabled = True
            Else
                Me.btnSpeichern.Enabled = False
            End If
        End If
    End Sub

    Private Sub frmBGExportProfileigenschaften_Load(sender As Object, e As System.EventArgs) Handles Me.Load

    End Sub

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        If Me._selectedProfile IsNot Nothing Then
            Me._selectedProfile.lastExport = "01.01.1990"
            txtlastExport.Text = "01.01.1990"
            Profil_speichern()
        End If

    End Sub
End Class